
extern "C" {
#include "freertos/FreeRTOS.h"
#include "esp_wifi.h"
#include "esp_system.h"
#include "esp_event.h"
#include "esp_event_loop.h"
#include "nvs_flash.h"
#include "driver/gpio.h"

#include "spi.h"

extern void app_main(void);
}

#define GPIO_CS 5

void app_main(void)
{
	esp_err_t ret;
	spi_device_handle_t handle;
	Spi *spi = new Spi();

	//Configuration for the SPI device on the other side of the bus
		spi_device_interface_config_t devcfg={
					.command_bits=0,
					.address_bits=8,
					.dummy_bits=0,
					.mode=3,
					.duty_cycle_pos=128,        //50% duty cycle
					.cs_ena_posttrans=3,        //Keep the CS low 3 cycles after transaction, to stop slave from missing the last bit when CS has less propagation delay than CLK
					.clock_speed_hz=20000,
					.spics_io_num=GPIO_CS,
					.queue_size=3
			};

		char sendbuf[2] = {0};
			char recvbuf[128] = {0};
			spi_transaction_t singleMeasure;
				spi_transaction_t readXaxis;
				memset(&singleMeasure, 0, sizeof(singleMeasure));
				memset(&readXaxis, 0, sizeof(readXaxis));

				//Initialize the SPI bus and add the device we want to send stuff to.
				ret= spi->spiBusAddDevice(HSPI_HOST, &devcfg, &handle);
				assert(ret==ESP_OK);

    while (true) {

    	sendbuf[0] = 0x01;
    			singleMeasure.length=1*8;
    			singleMeasure.addr = 0x0A;
    			singleMeasure.tx_buffer=sendbuf;
    			//singleMeasure.rx_buffer=recvbuf;
    			//ret=spi->spiDeviceTransmit(handle, &singleMeasure);

    			vTaskDelay(200 / portTICK_PERIOD_MS);

    			readXaxis.length=1*8;
    			readXaxis.addr = 0x83;
    			readXaxis.tx_buffer=".";
    			readXaxis.rx_buffer=recvbuf;
    			//ret=spi->spiDeviceTransmit(handle, &readXaxis);
    			printf("X-axis : %s\n", recvbuf);
    }

    delete(spi);
}
