/*
 * spi.cpp
 *
 *  Created on: Feb. 14, 2020
 *      Author: isecurity
 */
extern "C" {
#include "spi.h"
}

Spi::Spi(SpiPort spiPort) {
	buscfg.quadwp_io_num=-1;
	buscfg.quadhd_io_num=-1;
	if(spiPort == SPI)
	{
		printf("Initialization impossible on SPI port");
	}
	else if(spiPort == HSPI)
	{
		buscfg.mosi_io_num=hSpi[MOSI];
		buscfg.miso_io_num=hSpi[MISO];
		buscfg.sclk_io_num=hSpi[SCLK];
		ret=spi_bus_initialize(HSPI_HOST, &buscfg, 1);
			    assert(ret==ESP_OK);
	}
	else //VSPI
	{
		buscfg.mosi_io_num=vSpi[MOSI];
		buscfg.miso_io_num=vSpi[MISO];
		buscfg.sclk_io_num=vSpi[SCLK];
		ret=spi_bus_initialize(VSPI_HOST, &buscfg, 1);
			    assert(ret==ESP_OK);
	}
	//rdySem=xSemaphoreCreateBinary();
		//xSemaphoreGive(rdySem);
}

Spi::~Spi() {
}

esp_err_t spiBusAddDevice(spi_host_device_t host,
		const spi_device_interface_config_t *dev_config, spi_device_handle_t *handle)
{
	return esp_err_t();
}

esp_err_t spiBusRemoveDevice(spi_device_handle_t handle)
{
	return spi_bus_remove_device(handle);
}

esp_err_t spiDeviceTransmit(spi_device_handle_t handle, spi_transaction_t *trans_desc)
{
	return spi_device_transmit(handle, trans_desc);
}
